import Command from '../../command';
declare class ScopeConfigSet extends Command {
    name: string;
    description: string;
    alias: string;
    private: boolean;
    opts: never[];
    action([key, value]: [string, string]): Promise<any>;
    report({ key, value }: {
        key: string;
        value: number;
    }): string;
}
declare class ScopeConfigGet extends Command {
    name: string;
    description: string;
    alias: string;
    private: boolean;
    opts: never[];
    action([key]: [string]): Promise<any>;
    report(value: string): string;
}
declare class ScopeConfigList extends Command {
    name: string;
    description: string;
    alias: string;
    opts: never[];
    action(): Promise<any>;
    report(conf: {
        [key: string]: any;
    }): string;
}
declare class ScopeConfigDel extends Command {
    name: string;
    description: string;
    alias: string;
    opts: never[];
    action([key]: [string]): Promise<any>;
    report(): string;
}
export default class ScopeConfig extends Command {
    name: string;
    description: string;
    alias: string;
    commands: (ScopeConfigSet | ScopeConfigGet | ScopeConfigList | ScopeConfigDel)[];
    opts: never[];
    action(): Promise<any>;
    report(conf: {
        [key: string]: string;
    }): string;
}
export {};
