"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CapsuleCreate = exports.CapsuleList = void 0;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

function _lodash() {
  const data = _interopRequireDefault(require("lodash"));

  _lodash = function () {
    return data;
  };

  return data;
}

function _command() {
  const data = _interopRequireDefault(require("../../command"));

  _command = function () {
    return data;
  };

  return data;
}

function _consumer() {
  const data = require("../../../consumer");

  _consumer = function () {
    return data;
  };

  return data;
}

function _consumer2() {
  const data = require("../../../api/consumer");

  _consumer2 = function () {
    return data;
  };

  return data;
}

function _logger() {
  const data = require("../../../extensions/logger");

  _logger = function () {
    return data;
  };

  return data;
}

function _packageManager() {
  const data = require("../../../extensions/package-manager");

  _packageManager = function () {
    return data;
  };

  return data;
}

function _isolator() {
  const data = require("../../../extensions/isolator");

  _isolator = function () {
    return data;
  };

  return data;
}

function _utils() {
  const data = require("../../../utils");

  _utils = function () {
    return data;
  };

  return data;
}

// eslint-disable-next-line max-classes-per-file
class CapsuleList extends _command().default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2().default)(this, "name", 'capsule-list');
    (0, _defineProperty2().default)(this, "description", `list all capsules`);
    (0, _defineProperty2().default)(this, "alias", '');
    (0, _defineProperty2().default)(this, "opts", [['j', 'json', 'json format']]);
    (0, _defineProperty2().default)(this, "loader", true);
    (0, _defineProperty2().default)(this, "migration", true);
  }

  action() {
    return (0, _bluebird().coroutine)(function* () {
      const consumer = yield (0, _consumer().loadConsumerIfExist)();
      if (!consumer) throw new Error('no consumer found');
      const logger = new (_logger().Logger)();
      const packageManager = new (_packageManager().PackageManager)('librarian', logger); // const capsule = await Capsule.provide();

      const isolatorExt = yield _isolator().Isolator.provide([packageManager]);
      return isolatorExt.list(consumer);
    })();
  }

  report(capsuleListByWorkspace, ...args) {
    if (args[1].json) return JSON.stringify(capsuleListByWorkspace, null, '  ');
    return (0, _utils().render)(capsuleListByWorkspace);
  }

}

exports.CapsuleList = CapsuleList;

class CapsuleCreate extends _command().default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2().default)(this, "name", 'capsule-create [path...]');
    (0, _defineProperty2().default)(this, "description", `capsule`);
    (0, _defineProperty2().default)(this, "alias", '');
    (0, _defineProperty2().default)(this, "opts", [['b', 'baseDir <name>', 'set base dir of all capsules'], ['a', 'alwaysNew', 'create new environment for capsule'], ['i', 'id <name>', 'reuse capsule of certain name'], ['d', 'installPackages', 'install packages in capsule with npm']]);
    (0, _defineProperty2().default)(this, "loader", true);
    (0, _defineProperty2().default)(this, "migration", true);
  }

  action([values], {
    baseDir,
    alwaysNew = false,
    id,
    installPackages = false
  }) {
    return Promise.resolve((0, _consumer2().capsuleIsolate)(values, _lodash().default.omitBy({
      baseDir,
      installPackages,
      alwaysNew,
      name: id
    }, _lodash().default.isNil)));
  }

  report(capsuleObj) {
    const createdCapsules = Object.values(capsuleObj).map(capsule => {
      return {
        bitId: capsule.component.id.toString(),
        wrkDir: capsule.wrkDir
      };
    });
    return (0, _utils().render)(createdCapsules);
  }

}

exports.CapsuleCreate = CapsuleCreate;