import { ComponentFactoryExt } from '../component';
import { Environments } from '../environments';
import { React } from '../react';
import { ScopeExtension } from '../scope';
import { TesterExtension } from '../tester';
import { ReleasesExtension } from '../releases';
export declare const manifestsMap: {
    [x: string]: import("@teambit/harmony").ExtensionManifest | {
        name: string;
        dependencies: never[];
        config: {};
        provider: typeof import("../logger/logger.provider").provideLogger;
    } | {
        name: string;
        dependencies: {
            name: string;
            dependencies: never[];
            config: {};
            provider: typeof import("../logger/logger.provider").provideLogger;
        }[];
        config: {
            packageManager: string;
        };
        provider: typeof import("../package-manager/package-manager.provider").providePackageManager;
    } | typeof ComponentFactoryExt | typeof ScopeExtension | {
        name: string;
        dependencies: {
            name: string;
            dependencies: never[];
            config: {};
            provider: typeof import("../logger/logger.provider").provideLogger;
        }[];
        config: {};
        provider: typeof import("../reporter/reporter.provider").provideReporter;
    } | {
        name: string;
        dependencies: never[];
        config: {};
        provider: typeof import("../config/config.provider").default;
    } | {
        name: string;
        dependencies: {
            name: string;
            dependencies: {
                name: string;
                dependencies: never[];
                config: {};
                provider: typeof import("../logger/logger.provider").provideLogger;
            }[];
            config: {};
            provider: typeof import("../reporter/reporter.provider").provideReporter;
        }[];
        provider: typeof import("../paper/paper.provider").providePaper;
    } | typeof Environments | typeof ReleasesExtension | typeof TesterExtension | typeof React | {
        name: string;
        dependencies: import("@teambit/harmony").ExtensionManifest[];
        provider: typeof import("../watch/watch.provider").provideWatch;
    };
    '@teambit/envs': typeof Environments;
    Tester: typeof TesterExtension;
};
