"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CLIProvider = CLIProvider;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _cli() {
  const data = require("../../cli");

  _cli = function () {
    return data;
  };

  return data;
}

function _cli2() {
  const data = require("./cli");

  _cli2 = function () {
    return data;
  };

  return data;
}

function _legacyCommand() {
  const data = require("./legacy-command");

  _legacyCommand = function () {
    return data;
  };

  return data;
}

function _extensionsLoader() {
  const data = _interopRequireDefault(require("../../legacy-extensions/extensions-loader"));

  _extensionsLoader = function () {
    return data;
  };

  return data;
}

function CLIProvider(_x) {
  return _CLIProvider.apply(this, arguments);
}

function _CLIProvider() {
  _CLIProvider = (0, _bluebird().coroutine)(function* ([paper]) {
    const legacyExtensions = yield (0, _extensionsLoader().default)(); // Make sure to register all the hooks actions in the global hooks manager

    legacyExtensions.forEach(extension => {
      extension.registerHookActionsOnHooksManager();
    });
    const extensionsCommands = legacyExtensions.reduce((acc, curr) => {
      if (curr.commands && curr.commands.length) {
        // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
        acc = acc.concat(curr.commands);
      }

      return acc;
    }, []);
    const legacyRegistry = (0, _cli().buildRegistry)(extensionsCommands);
    const bitCLI = new (_cli2().BitCli)(paper);
    const allCommands = legacyRegistry.commands.concat(legacyRegistry.extensionsCommands || []);
    allCommands.reduce((p, command) => {
      const legacyCommand = new (_legacyCommand().LegacyCommand)(command, p);
      p.register(legacyCommand);
      return p;
    }, paper);
    return bitCLI;
  });
  return _CLIProvider.apply(this, arguments);
}