import React from 'react';
import { Command, PaperOptions, GenericObject } from '../paper';
import LegacyInterface from '../../cli/command';
import { Paper } from '../paper';
export declare class LegacyCommand implements Command {
    private cmd;
    alias: string;
    name: string;
    description: string;
    options: PaperOptions;
    shortDescription: string;
    group: string;
    loader?: boolean;
    commands: Command[];
    private?: boolean;
    migration?: boolean;
    constructor(cmd: LegacyInterface, p: Paper);
    private action;
    render(params: any, options: {
        [key: string]: any;
    }): Promise<React.ReactElement>;
    json(params: any, options: {
        [key: string]: any;
    }): Promise<GenericObject>;
}
export declare function findLegacyDetails(name: string, p: Paper): {
    group: string;
    summery: string;
};
export declare function LegacyRender(props: {
    out: string;
    code: number;
}): JSX.Element;
