"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.findLegacyDetails = findLegacyDetails;
exports.LegacyRender = LegacyRender;
exports.LegacyCommand = void 0;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

function _ink() {
  const data = require("ink");

  _ink = function () {
    return data;
  };

  return data;
}

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function () {
    return data;
  };

  return data;
}

function _allHelp() {
  const data = _interopRequireDefault(require("../../cli/templates/all-help"));

  _allHelp = function () {
    return data;
  };

  return data;
}

function _paper() {
  const data = require("../paper");

  _paper = function () {
    return data;
  };

  return data;
}

// eslint-disable-next-line @typescript-eslint/no-unused-vars
class LegacyCommand {
  constructor(cmd, p) {
    this.cmd = cmd;
    (0, _defineProperty2().default)(this, "alias", void 0);
    (0, _defineProperty2().default)(this, "name", void 0);
    (0, _defineProperty2().default)(this, "description", void 0);
    (0, _defineProperty2().default)(this, "options", void 0);
    (0, _defineProperty2().default)(this, "shortDescription", void 0);
    (0, _defineProperty2().default)(this, "group", void 0);
    (0, _defineProperty2().default)(this, "loader", void 0);
    (0, _defineProperty2().default)(this, "commands", void 0);
    (0, _defineProperty2().default)(this, "private", void 0);
    (0, _defineProperty2().default)(this, "migration", void 0);
    this.name = cmd.name;
    this.description = cmd.description;
    this.options = cmd.opts;
    this.alias = cmd.alias;
    const commandID = (0, _paper().getID)(cmd.name);
    const {
      summery,
      group
    } = findLegacyDetails(commandID, p);
    this.shortDescription = summery;
    this.group = group;
    this.loader = cmd.loader;
    this.private = cmd.private;
    this.migration = cmd.migration;
    this.commands = cmd.commands.map(sub => {
      return new LegacyCommand(sub, p);
    });
  }

  action(params, options) {
    var _this = this;

    return (0, _bluebird().coroutine)(function* () {
      let report = null; //  packageManagerArgs is injected here for legacy reasons.

      const res = yield _this.cmd.action(params, options, _this.packageManagerArgs || []);
      let data = res;

      if (res && res.data !== undefined) {
        data = res.data;
      }

      report = _this.cmd.report && _this.cmd.report(data, params, options);
      return {
        code: (res === null || res === void 0 ? void 0 : res.__code) || 0,
        report: report || ''
      };
    })();
  }

  render(params, options) {
    var _this2 = this;

    return (0, _bluebird().coroutine)(function* () {
      const actionResult = yield _this2.action(params, options);
      return /*#__PURE__*/_react().default.createElement(LegacyRender, {
        out: actionResult.report,
        code: actionResult.code
      });
    })();
  }

  json(params, options) {
    var _this3 = this;

    return (0, _bluebird().coroutine)(function* () {
      const actionResult = yield _this3.action(params, options);
      return {
        data: JSON.parse(actionResult.report),
        code: actionResult.code
      };
    })();
  }

} // TODO: remove all help and move information to commands


exports.LegacyCommand = LegacyCommand;

function findLegacyDetails(name, p) {
  let group = '';
  let summery = '';

  for (let i = 0; i < _allHelp().default.length; i += 1) {
    const index = _allHelp().default[i].commands.findIndex(command => command.name === name); // eslint-disable-next-line no-bitwise


    if (~index) {
      group = _allHelp().default[i].group;
      summery = _allHelp().default[i].commands[index].description;
      !p.groups[group] && p.registerGroup(group, _allHelp().default[i].title);
    }
  }

  return {
    group,
    summery
  };
}

function LegacyRender(props) {
  return /*#__PURE__*/_react().default.createElement(_ink().AppContext.Consumer, null, ({
    exit
  }) => {
    setTimeout(() => {
      exit();
    }, 0);
    return /*#__PURE__*/_react().default.createElement(_ink().Color, null, props.out);
  });
}