"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _flows() {
  const data = require("./flows");

  _flows = function () {
    return data;
  };

  return data;
}

function _cli() {
  const data = require("../cli");

  _cli = function () {
    return data;
  };

  return data;
}

function _workspace() {
  const data = require("../workspace");

  _workspace = function () {
    return data;
  };

  return data;
}

function _run() {
  const data = require("./run");

  _run = function () {
    return data;
  };

  return data;
}

function _reporter() {
  const data = require("../reporter");

  _reporter = function () {
    return data;
  };

  return data;
}

function _logger() {
  const data = require("../logger");

  _logger = function () {
    return data;
  };

  return data;
}

var _default = {
  name: 'flows',
  dependencies: [_cli().BitCliExt, _workspace().WorkspaceExt, _reporter().ReporterExt, _logger().LoggerExt],

  provider([cli, workspace, reporter, logger]) {
    return (0, _bluebird().coroutine)(function* () {
      const flows = new (_flows().Flows)(workspace);
      const runCMD = new (_run().RunCmd)(flows, reporter, logger);
      cli.register(runCMD);
      return flows;
    })();
  }

};
exports.default = _default;