"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Install = void 0;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _fsExtra() {
  const data = _interopRequireDefault(require("fs-extra"));

  _fsExtra = function () {
    return data;
  };

  return data;
}

function _path() {
  const data = _interopRequireDefault(require("path"));

  _path = function () {
    return data;
  };

  return data;
}

function _componentIdToPackageName() {
  const data = _interopRequireDefault(require("../../utils/bit/component-id-to-package-name"));

  _componentIdToPackageName = function () {
    return data;
  };

  return data;
}

function _constants() {
  const data = require("../../constants");

  _constants = function () {
    return data;
  };

  return data;
}

function symlinkCapsulesInNodeModules(_x) {
  return _symlinkCapsulesInNodeModules.apply(this, arguments);
}

function _symlinkCapsulesInNodeModules() {
  _symlinkCapsulesInNodeModules = (0, _bluebird().coroutine)(function* (isolatedEnvs) {
    yield Promise.all(isolatedEnvs.map( /*#__PURE__*/function () {
      var _ref = (0, _bluebird().coroutine)(function* (e) {
        const componentPackageName = (0, _componentIdToPackageName().default)(e.component.id.legacyComponentId, _constants().DEFAULT_REGISTRY_DOMAIN_PREFIX);

        const linkPath = _path().default.join(process.cwd(), 'node_modules', componentPackageName);

        yield _fsExtra().default.mkdirp(_path().default.dirname(linkPath));
        yield _fsExtra().default.symlink(e.capsule.wrkDir, linkPath);
      });

      return function (_x3) {
        return _ref.apply(this, arguments);
      };
    }()));
  });
  return _symlinkCapsulesInNodeModules.apply(this, arguments);
}

function removeExistingLinksInNodeModules(_x2) {
  return _removeExistingLinksInNodeModules.apply(this, arguments);
}

function _removeExistingLinksInNodeModules() {
  _removeExistingLinksInNodeModules = (0, _bluebird().coroutine)(function* (isolatedEnvs) {
    yield Promise.all(isolatedEnvs.map( /*#__PURE__*/function () {
      var _ref2 = (0, _bluebird().coroutine)(function* (e) {
        const componentPackageName = (0, _componentIdToPackageName().default)(e.component.id.legacyComponentId, _constants().DEFAULT_REGISTRY_DOMAIN_PREFIX);

        try {
          yield _fsExtra().default.unlink(_path().default.join(process.cwd(), 'node_modules', componentPackageName));
        } catch (err) {
          // if the symlink does not exist - no problem
          if (err.code !== 'ENOENT') {
            throw err;
          }
        }
      });

      return function (_x4) {
        return _ref2.apply(this, arguments);
      };
    }()));
  });
  return _removeExistingLinksInNodeModules.apply(this, arguments);
}

class Install {
  constructor(workspace, packageManager, reporter) {
    this.workspace = workspace;
    this.packageManager = packageManager;
    this.reporter = reporter;
  }

  install() {
    var _this = this;

    return (0, _bluebird().coroutine)(function* () {
      //      this.reporter.info('Installing component dependencies');
      //      this.reporter.setStatusText('Installing');
      const components = yield _this.workspace.list(); // this.reporter.info('Isolating Components');

      const isolatedEnvs = yield _this.workspace.load(components.map(c => c.id.toString()));

      const packageManagerName = _this.workspace.consumer.config.packageManager || _constants().DEFAULT_PACKAGE_MANAGER; // this.reporter.info('Installing workspace dependencies');


      yield removeExistingLinksInNodeModules(isolatedEnvs);
      yield _this.packageManager.runInstallInFolder(process.cwd(), {
        packageManager: packageManagerName
      });
      yield symlinkCapsulesInNodeModules(isolatedEnvs); // this.reporter.end();

      return isolatedEnvs;
    })();
  }

}

exports.Install = Install;