import { PackageManager } from '../package-manager';
import Consumer from '../../consumer/consumer';
import CapsuleList from './capsule-list';
import Graph from '../../scope/graph/graph';
export declare type IsolatorDeps = [PackageManager];
export declare type ListResults = {
    workspace: string;
    capsules: string[];
};
export declare type Network = {
    capsules: CapsuleList;
    components: Graph;
};
export default class Isolator {
    private packageManager;
    constructor(packageManager: PackageManager);
    static provide([packageManager]: IsolatorDeps): Promise<Isolator>;
    createNetworkFromConsumer(seeders: string[], consumer: Consumer, opts?: {}): Promise<Network>;
    createNetworkFromScope(seeders: string[], opts?: {}): Promise<Network>;
    createNetwork(seeders: string[], graph: Graph, baseDir: any, opts?: {}): Promise<{
        capsules: CapsuleList;
        components: Graph;
    }>;
    list(consumer: Consumer): Promise<ListResults[] | ListResults>;
}
