import { Logger } from '../logger';
import { Capsule } from '../isolator';
export declare type installOpts = {
    packageManager?: string;
};
export declare function onCapsuleInstalled(cb: any): void;
export declare function beforeInstallingCapsules(cb: any): void;
export default class PackageManager {
    readonly packageManagerName: string;
    readonly logger: Logger;
    private emitter;
    constructor(packageManagerName: string, logger: Logger);
    get name(): string;
    checkIfFileExistsInCapsule(capsule: Capsule, file: string): Promise<boolean>;
    removeLockFilesInCapsule(capsule: Capsule): Promise<void>;
    runInstall(capsules: Capsule[], opts?: installOpts): Promise<any>;
    runInstallInFolder(folder: string, opts?: installOpts): Promise<null>;
}
