/// <reference types="react" />
import { CommandOptions } from '../../cli/command';
export interface Command {
    name: string;
    alias?: string;
    shortDescription?: string;
    description?: string;
    group?: string;
    private?: boolean;
    loader?: boolean;
    options?: PaperOptions;
    commands?: Command[];
    render: (args: CLIArgs, flags: Flags) => Promise<React.ReactElement>;
    json?: (args: CLIArgs, flags: Flags) => GenericObject;
}
export declare type Flags = {
    [flagName: string]: any;
};
export declare type CLIArgs = Array<string[] | string>;
export declare type GenericObject = {
    [k: string]: any;
};
export declare type PaperOptions = CommandOptions;
