"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getID = getID;
exports.default = void 0;

function _exceptions() {
  const data = require("./exceptions");

  _exceptions = function () {
    return data;
  };

  return data;
}

// eslint-disable-next-line import/named
class CommandRegistry {
  constructor(commands) {
    this.commands = commands;
  }
  /**
   * register a new command
   */


  register(command) {
    const key = CommandRegistry.getID(command);

    if (this.commands[key]) {
      throw new (_exceptions().AlreadyExistsError)('Command', key);
    }

    this.commands[key] = command;
    return this;
  }
  /**
   * return a command unique ID.
   */


  static getID(cmd) {
    return getID(cmd.name);
  }

}

exports.default = CommandRegistry;

function getID(cmd) {
  return cmd.split(' ')[0].trim();
}