import { Environment } from '../environments';
import { Tester, TesterExtension } from '../tester';
import { Component } from '../component';
import { Workspace } from '../workspace';
import { LogPublisher } from '../logger';
import { JestExtension } from '../jest';
import { TypescriptExtension } from '../typescript';
import { Compiler, Compile } from '../compile';
import { ReleasePipe } from '../releases';
export declare class ReactEnv implements Environment {
    private logger;
    private jest;
    private ts;
    private compile;
    private tester;
    constructor(logger: LogPublisher, jest: JestExtension, ts: TypescriptExtension, compile: Compile, tester: TesterExtension);
    patchComponents(components: Component[], workspace: Workspace): Component[];
    getLinter(): void;
    getTester(): Tester;
    getCompiler(): Compiler;
    getPipe(): ReleasePipe;
    dev(workspace: Workspace, components: Component[]): void;
    private getEntries;
}
