"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReleasePipe = void 0;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

/**
 * Context of a release
 */

/**
 * release task.
 */
class ReleasePipe {
  constructor(tasks) {
    this.tasks = tasks;
  }
  /**
   * execute a pipeline of release tasks.
   */


  execute(releaseContext) {
    var _this = this;

    return (0, _bluebird().coroutine)(function* () {
      return Promise.all(_this.tasks.map(task => task.execute(releaseContext)));
    })();
  }
  /**
   * create a release pipe from an array of services.
   */


  static from(tasks) {
    return new ReleasePipe(tasks);
  }

}

exports.ReleasePipe = ReleasePipe;