import { BitCli } from '../cli';
import { Environments } from '../environments';
import { Workspace } from '../workspace';
import { Component } from '../component';
import { ReleasesService } from './releases.service';
import { BitId } from '../../bit-id';
import { ScopeExtension } from '../scope';
import { Isolator } from '../isolator';
export declare type ReleasesConfig = {
    parallel: 10;
};
export declare class ReleasesExtension {
    private envs;
    private workspace;
    private service;
    static dependencies: (import("@teambit/harmony").ExtensionManifest | typeof ScopeExtension | typeof Environments)[];
    constructor(envs: Environments, workspace: Workspace, service: ReleasesService);
    tagListener(ids: BitId[]): Promise<{
        env: string;
        res: any;
    }[]>;
    release(components?: Component[]): Promise<{
        env: string;
        res: any;
    }[]>;
    static provider([cli, envs, workspace, scope, isolator]: [BitCli, Environments, Workspace, ScopeExtension, Isolator]): Promise<ReleasesExtension>;
}
