"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReleasesExtension = void 0;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

function _cli() {
  const data = require("../cli");

  _cli = function () {
    return data;
  };

  return data;
}

function _environments() {
  const data = require("../environments");

  _environments = function () {
    return data;
  };

  return data;
}

function _workspace() {
  const data = require("../workspace");

  _workspace = function () {
    return data;
  };

  return data;
}

function _run() {
  const data = require("./run.cmd");

  _run = function () {
    return data;
  };

  return data;
}

function _releases() {
  const data = require("./releases.service");

  _releases = function () {
    return data;
  };

  return data;
}

function _scope() {
  const data = require("../scope");

  _scope = function () {
    return data;
  };

  return data;
}

function _isolator() {
  const data = require("../isolator");

  _isolator = function () {
    return data;
  };

  return data;
}

class ReleasesExtension {
  /**
   * extension dependencies
   */
  constructor(envs, workspace, service) {
    this.envs = envs;
    this.workspace = workspace;
    this.service = service;
  }

  tagListener(ids) {
    var _this = this;

    return (0, _bluebird().coroutine)(function* () {
      // @todo: some processes needs dependencies/dependents of the given ids
      const components = yield _this.workspace.getMany(ids);
      return _this.release(components);
    })();
  }
  /**
   * build given components for release.
   */


  release(components) {
    var _this2 = this;

    return (0, _bluebird().coroutine)(function* () {
      const envs = yield _this2.envs.createEnvironment(components);
      const buildResult = yield envs.run(_this2.service);
      return buildResult;
    })();
  }

  static provider([cli, envs, workspace, scope, isolator]) {
    return (0, _bluebird().coroutine)(function* () {
      const releasesService = new (_releases().ReleasesService)(isolator, workspace);
      const releases = new ReleasesExtension(envs, workspace, releasesService);
      const func = releases.tagListener.bind(releases);
      if (scope) scope.onTag(func);
      cli.register(new (_run().ReleaserCmd)(releases, workspace));
      return releases;
    })();
  }

}

exports.ReleasesExtension = ReleasesExtension;
(0, _defineProperty2().default)(ReleasesExtension, "dependencies", [_cli().BitCliExt, _environments().Environments, _workspace().WorkspaceExt, _scope().ScopeExtension, _isolator().IsolatorExt]);