"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReleasesService = void 0;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

class ReleasesService {
  constructor(isolator, workspace) {
    this.isolator = isolator;
    this.workspace = workspace;
  }
  /**
   * runs a pipeline of tasks on all components in the execution context.
   */


  run(context) {
    var _this = this;

    return (0, _bluebird().coroutine)(function* () {
      // make release pipe accessible throughout the context.
      const releasePipe = context.env.getPipe(context);

      if (!releasePipe) {
        throw new Error(`releaser service expects ${context.id} to implement getPipe()`);
      }

      const releaseContext = Object.assign(context, {
        capsuleGraph: yield _this.isolator.createNetworkFromConsumer(context.components.map(component => component.id.toString()), _this.workspace.consumer)
      });
      const results = yield releasePipe.execute(releaseContext);
      return {
        id: context.id,
        results
      };
    })();
  }

}

exports.ReleasesService = ReleasesService;