import ts from 'typescript';
import { Compiler } from '../compile';
export declare class TypescriptCompiler implements Compiler {
    readonly tsConfig: Record<string, any>;
    constructor(tsConfig: Record<string, any>);
    compileFile(fileContent: string, options: {
        componentDir: string;
        filePath: string;
    }): {
        outputText: string;
        outputPath: string;
    }[] | null;
    compileOnCapsules(capsuleDirs: string[]): {
        resultCode: ts.ExitStatus;
        error: Error | null;
    };
}
