import { Harmony } from '@teambit/harmony';
import { ScopeExtension } from '../scope';
import Workspace from './workspace';
import { ComponentFactory } from '../component';
import { Isolator } from '../isolator';
import { Logger } from '../logger';
import { DependencyResolver } from '../dependency-resolver';
import { Variants } from '../variants';
import { WorkspaceExtConfig } from './types';
export declare type WorkspaceDeps = [ScopeExtension, ComponentFactory, Isolator, DependencyResolver, Variants, Logger];
export declare type WorkspaceCoreConfig = {
    componentsDefaultDirectory: string;
    defaultScope: string;
    defaultOwner: string;
};
export default function provideWorkspace([scope, component, isolator, dependencyResolver, variants, logger]: WorkspaceDeps, config: WorkspaceExtConfig, _slots: any, harmony: Harmony): Promise<Workspace | undefined>;
